# This file was created automatically by SWIG.
import solverdriverc
class SolverDriverCorePtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def nrows(self, *_args, **_kwargs):
        val = apply(solverdriverc.SolverDriverCore_nrows,(self,) + _args, _kwargs)
        return val
    def ncols(self, *_args, **_kwargs):
        val = apply(solverdriverc.SolverDriverCore_ncols,(self,) + _args, _kwargs)
        return val
    def precompute(self, *_args, **_kwargs):
        val = apply(solverdriverc.SolverDriverCore_precompute,(self,) + _args, _kwargs)
        return val
    def solve(self, *_args, **_kwargs):
        val = apply(solverdriverc.SolverDriverCore_solve,(self,) + _args, _kwargs)
        return val
    def postcompute(self, *_args, **_kwargs):
        val = apply(solverdriverc.SolverDriverCore_postcompute,(self,) + _args, _kwargs)
        return val
    def residual(self, *_args, **_kwargs):
        val = apply(solverdriverc.SolverDriverCore_residual,(self,) + _args, _kwargs)
        return val
    def clear_memory(self, *_args, **_kwargs):
        val = apply(solverdriverc.SolverDriverCore_clear_memory,(self,) + _args, _kwargs)
        return val
    def __del__(self,solverdriverc=solverdriverc):
        if self.thisown == 1 :
            solverdriverc.delete_SolverDriverCore(self)
    def __repr__(self):
        return "<C SolverDriverCore instance at %s>" % (self.this,)
class SolverDriverCore(SolverDriverCorePtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverdriverc.new_SolverDriverCore,_args,_kwargs)
        self.thisown = 1




class NewtonDriverCorePtr(SolverDriverCorePtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def precompute(self, *_args, **_kwargs):
        val = apply(solverdriverc.NewtonDriverCore_precompute,(self,) + _args, _kwargs)
        return val
    def solve(self, *_args, **_kwargs):
        val = apply(solverdriverc.NewtonDriverCore_solve,(self,) + _args, _kwargs)
        return val
    def postcompute(self, *_args, **_kwargs):
        val = apply(solverdriverc.NewtonDriverCore_postcompute,(self,) + _args, _kwargs)
        return val
    def residual(self, *_args, **_kwargs):
        val = apply(solverdriverc.NewtonDriverCore_residual,(self,) + _args, _kwargs)
        return val
    def __del__(self,solverdriverc=solverdriverc):
        if self.thisown == 1 :
            solverdriverc.delete_NewtonDriverCore(self)
    def __repr__(self):
        return "<C NewtonDriverCore instance at %s>" % (self.this,)
class NewtonDriverCore(NewtonDriverCorePtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(solverdriverc.new_NewtonDriverCore,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: solverdriver.spy,v $
# $Revision: 1.20 $
# $Author: rlua $
# $Date: 2007-09-28 03:20:50 $


# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from ooflib.SWIG.common import ooferror
from ooflib.SWIG.common import switchboard
from ooflib.SWIG.common.IO import progressbar
from ooflib.SWIG.engine import ooferror2
from ooflib.SWIG.engine import solver
from ooflib.common import debug
from ooflib.common import registeredclass
from ooflib.common.IO import parameter
from ooflib.common.IO import reporter
from ooflib.common.IO import xmlmenudump
from ooflib.engine import conjugate
from ooflib.engine import symstate
from ooflib.common import parallel_enable
import ooflib.engine.mesh

## Solver Iterator Managers for Drivers start HERE

## A SolverIteratorManager is a class that keeps track of the state of
## the iterations and the used solver. If the linear solver used fails
## or the maximum number of iterations is reached the
## SolverIterationManager raises a flag that the is used by the Driver
## to bail out of the loop or do something appropriate.

class SolverIterationManager:
    def __init__(self, max_steps):
        self.max_steps = max_steps
        self.nsteps = 0
        self.status_msg = None
    def get_nsteps(self):
        return self.nsteps

    # Call status() to see if the iteration should stop.  If the
    # return value is False (or None or 0 or "") the iteration will
    # continue.
    def status(self):
        msg = self.checkstatus()
        self.status_msg = self.status_msg or msg
        return self.status_msg

    # Call start() before beginning to iterate.  The iteration may be
    # taking place in a different thread from the construction of the
    # SolverIterationManager.  start() must be called in the iteration
    # thread.
    def start(self):
        self.progress = progressbar.getProgress()
    # Call step_completed() at the conclusion of each solver step
    def step_completed(self):
        self.nsteps += 1
        msg = self.status()
        if not msg:
            self.progress.set_progress(1.0*self.nsteps/self.max_steps)
            self.progress.set_message("%d/%d" % (self.nsteps, self.max_steps))
        else:
            self.progress.set_message(msg)

    # Override this function in derived classes.  It returns an
    # explanatory message if the iteration should stop, and None if it
    # should continue.
    def checkstatus(self):
        if self.nsteps > self.max_steps:
            return "Too many steps!"
        if self.progress.query_stop():
            return "Interrupted!"
        if self.progress.get_success() == progressbar.FAILED:
            return "Linear solver failed!"
        

class NewtonIterationManager(SolverIterationManager):
    def __init__(self, max_steps, tolerance):
        self.tolerance = tolerance
        self.residual = None
        SolverIterationManager.__init__(self, max_steps)
    def checkstatus(self):
        if self.residual is not None and self.residual < self.tolerance:
            return "Succeeded"
        return SolverIterationManager.checkstatus(self)
    def set_residual(self, residual):
        self.residual = residual
        self.checkstatus()
    def get_residual(self):
        return self.residual
        

            
## Iterator Managers for Drivers END HERE





################################################
##                                            ##
################################################

## Drivers START HERE

            
## Driver is the base class of all the solver methods (Linear, Newton)
## to calculate the solution of a matrix equation at a single point in
## time.


class Driver(registeredclass.RegisteredClass):
    registry = []
    ## the base driver class does not have a constructor, and only a
    ## wrapper for "apply". It only knows how to build (precompute)
    ## its effective stifness matrix.  The sublclasses make use of
    ## this common functionality by using their own methods

    # This "apply" just records the mesh context and computes the
    # target time.  The real work is done by the subclass's
    # "driver_apply" routine, which builds self.core and iterates (or
    # not).
    def apply(self, stepper, subproblemcontext, verbosity = 1):
        self.subproblemctxt = subproblemcontext
        self.subproblem = subproblemcontext.getObject()
        self.femesh = subproblemcontext.getParent().getObject()
        self.target_time = \
                      self.subproblem.current_time() + stepper.get_dt()
        self.driver_apply(stepper, verbosity)
    
    def precompute(self, verbosity = 1):
        ##
        ## if verbosity is 1, then the progress bar mechanisms
        ## of this member function are activated and pbar messages
        ## will be displayed. In any other case, this function
        ## will remain pbar-silent
        ## 
        ## Here, the finite element mesh is built: stiffness matrix,
        ## boundary conditions are assigned, floating boundary nodes
        ## are promoted, dofs are mapped, and the actual A, x, and b objects
        ## are created (for solving the A x = b)
        ##
        ########################################
        ## first check for quality of materials
        ########################################
        badmatls = self.subproblemctxt.check_materials()
        if badmatls:
            raise ooferror2.ErrUserError(badmatls)

        ## grab the associated progress object
        eq_Progress = progressbar.getProgress()
        ########################################
        ## end check for quality of materials
        ########################################

        ########################################
        ## start precompute materials
        ########################################        
        # precompute must be called before anything else that
        # might want to check if a Property is active.
        ##
        ## precompute checks list of materials is unique
        ## and precomputes materials
        self.subproblem.precompute()

        
        if verbosity:
            reporter.start_progressbar()
        ########################################
        ## end precompute materials
        ########################################  
        


        ########################################
        ## mapping to make stiffness matrix symmetric
        ########################################
        if self.subproblemctxt.get_symmetry_state() == symstate.INCONSISTENT:
            self.subproblem.set_trivial_equation_mapping()
        else:
            conjugate.listofconjugatepairs.find_equation_mapping(
                self.subproblemctxt)


        ########################################
        ## MASTER STIFFNESS MATRIX IS CONSTRUCTED HERE
        ########################################
        self.subproblem.make_linear_system()
        ## makes stiffness matrix and rhs
        ## If equations and fields are propertly defined
        ## each material parameter successfully contributes
        ## to the stiffness matrix and RHS
        ########################################
        ## END OF STIFFNESS MATRIX CONSTRUCTION
        ########################################
        if verbosity:
            reporter.progressbar_completed()
            reporter.end_progressbar()

        ## If process failed equilibration sequence is aborted
        if eq_Progress.query_stop() !=0:
            eq_Progress.set_failure()
            eq_Progress.set_progress(1)
            eq_Progress.set_message("Interrupted") ## GUI message
            if verbosity:
                reporter.progressbar_cleanup()
                reporter.warn("Process interrupted")
            raise ooferror.ErrProcessAborted('stiffness matrix construction')
    
        ########################################
        ## BOUNDARY CONDITIONS CONSTRUCTION AND
        ## PROMOTION STARTS HERE
        ########################################
        ## Initialize the vector that records the boundary's contribution
        ##  to the RHS.  Correct size, full of zeros.
        self.subproblem.clear_brhs()

        ## Reset old BCs
        self.femesh.reset_bcs()
        # Make sure all dofs and equations are initially free/independent.
        self.subproblem.resetdofeqs()

        ########################################
        ## Resolve intersecting float/fixed BC's, and check fixed BC's.
        ##
        ## Note to developers:
        ## 
        ## Intersecting BC means that more than one boundary condition
        ## is specified at the boundary nodes (i.e., the intersection of
        ## two sets of nodes with user-specified BCs is not null, but
        ## not necessarily redundant).
        ##
        ## A floating boundary condition is one where only the difference
        ## of the values between neighboring nodes is specified. The
        ## field value is not fixed at the node, except when the node
        ## intersects a BC which is fixed (in which case it is promoted).
        ##
        ## A fixed BC is that one where the nodal value of the field
        ## is specified.
        ##
        ## A promoted BC node/dof is a node that is changed in status
        ## from floating to fixed.
        ##
        ## A BC is promoted if it is initially float, but made fixed
        ## if it "intersects" in at least one node with a fixed dof,
        ## thus, directly specifying (fixing) the BC.
        ########################################

        #Interface branch
        self.femesh.createInterfaceFloatBCs(self.subproblemctxt)

        # These functions need to know the time in order to evaluate
        # potentially time-dependent boundary-condition profiles.
        # These are important for computing offsets in BC promotion,
        # and for checking intersection consistency.

        while self.femesh.bcPromote(self.subproblem, self.target_time): 
            # Explore beautiful British Columbia!!
            pass
        
        
        self.femesh.fixedBCConsistency(self.subproblem, self.target_time)
        if debug.debug() and verbosity:
            reporter.report("Completed Fixed BC consistency checks.")
        
        self.femesh.floatBCResolve(self.subproblem, self.target_time)
        if debug.debug() and verbosity:
            reporter.report("Resolved floating BC intersections, if any.")
        
        self.femesh.invoke_flux_bcs(self.subproblem, self.target_time)
        if debug.debug() and verbosity:
            reporter.report("Applied flux boundary conditions, if any.")
        self.femesh.invoke_fixed_bcs(self.subproblem, self.target_time)
        if debug.debug() and verbosity:
            reporter.report("Applied fixed boundary conditions, if any.")
        self.femesh.invoke_force_bcs(self.subproblem, self.target_time)
        if debug.debug() and verbosity:
            reporter.report("Applied force boundary conditions, if any.")

        # mapdofeqs must come after fixed bcs, before floating ones
        self.subproblem.mapdofeqs()

        if parallel_enable.enabled():
            self.subproblem.set_parallel_mapping()

        if debug.debug() and verbosity:
            reporter.report("Mapped equations.")
        self.femesh.invoke_float_bcs(self.subproblem, self.target_time)
        if debug.debug() and verbosity:
            reporter.report("Applied floating boundary conditions, if any.")
        ########################################
        ## BOUNDARY CONDITIONS CONSTRUCTION AND
        ## PROMOTION ENDS HERE
        ########################################

        ########################################
        ## ACTUALLY BUILD THE STIFFNESS MATRIX
        ########################################
        ## The next line is the very last thing that must be done
        ## before actually solving the mesh.  It allocates memory and
        ## builds the actual A-matrix, b-vector, x-vector to solve the
        ## system Ax=b
        self.core.precompute()

        ## report stiffness matrix size
        if verbosity:
            rows_A_matrix = self.core.nrows()
            cols_A_matrix = self.core.ncols()
            reporter.report("Made %dx%d stiffness matrix" % (rows_A_matrix,
                                                             cols_A_matrix))
    
    def apply_solver(self, verbosity = 1):
        eq_Progress = progressbar.getProgress()
        eq_Progress.reset()    # this may not be the right place to do this
        if verbosity:
            reporter.start_progressbar()
        self.status = self.core.solve()
        if eq_Progress.query_stop():
            raise ooferror.ErrProcessAborted('solution')
        if verbosity:
            reporter.progressbar_completed()
            reporter.end_progressbar()
            
    def postcompute(self, verbosity = 1):
        ##
        ## Here, floating BCs are expanded, reset,
        ## and history-dependent fields are fixated
        ##
        self.core.postcompute()
        eq_Progress = progressbar.getProgress()
        if self.status:
            self.femesh.expand_float_bcs(self.subproblem, self.target_time)
            if debug.debug() and verbosity:
                reporter.report("Expanded floating BC's, if any.")
            self.subproblemctxt.solutiontimestamp.increment()
            ## this is done so GUI is updated

        # Earliest opportunity to remove automatically-generated fixed
        # BCs caused by promotion.
        self.femesh.reset_bcs()         ## not too expensive
        if verbosity:
            reporter.start_progressbar()
        ## plasticity fixation and memory effects are set in post_process().
        self.subproblem.post_process()
        if verbosity:
            reporter.end_progressbar()
        if debug.debug() and verbosity:
            reporter.report("Completed post-processing, if any.")
        if verbosity:
            reporter.progressbar_cleanup()
        if not eq_Progress.get_success() or \
               not eq_Progress.query_stop():
            info = self.method.message()
            if verbosity:
                reporter.report(info)
        
        
    def redraw(self):
        switchboard.notify('redraw')
    

    def update_solver_state(self, success):
        debug.fmsg('success=', success)
        ## synchronizes the state of the progress object
        ## and what will be displayed in the Solver GUI page
        prgrss = progressbar.getProgress()
        message = self.method.message()
        ## If you made it this far without failing
        ## it means you succeeded, even if you press
        ## the stop button now
        if prgrss.get_success() == progressbar.INCOMPLETE:
            if success == 1:
                prgrss.set_success()
            prgrss.set_message("Succeeded")
            if len(message.split()) < 2: ## first word is the name of the solver
                message += ' converged in zero iterations!'
            self.subproblemctxt.setSolverStatus('completed', self.method,
                                                   message)
        else:
            if prgrss.query_stop():
                self.subproblemctxt.setSolverStatus('interrupted',
                                                       self.method, message)
            else:
                self.subproblemctxt.setSolverStatus('failed', self.method,
                                                       message)
            prgrss.set_failure()
            prgrss.set_message("Failed")
        switchboard.notify('mesh solved', self.subproblemctxt)

    def clear_memory(self):
        if self.core is not None:
            self.core.clear_memory()
        
    tip = "Solver iteration manager."
    discussion = xmlmenudump.loadFile(
         'DISCUSSIONS/engine/reg/solver_driver.xml')

## LinearDriver is a single-step linear solver.
## It is basically a wrapper for the solver(s).
## It is meant to provide a uniform interface to the
## linear solver page.


class LinearDriver(Driver):
    def __init__(self, method):
        self.method = method
        self.core = None

    def driver_apply(self, stepper, verbosity):
        self.core = SolverDriverCore(stepper, self.method, self.subproblem)
        self.precompute(verbosity)
        ## precompute assigns properties, creates the mapping to
        ## symmetrize the linear system of equations,
        ## builds the master stiffness, conductivity, and mass
        ## matrices, sets BCs
        self.apply_solver(verbosity) ## applies the linear solver. Solution is accepted HERE
        self.postcompute(verbosity)
        ## postcompute resets BCs and fixates history


registeredclass.Registration(
    'LinearDriver',
    Driver, ## superclass
    LinearDriver, ## subclass
    ordering = 100,
    params = [
    solver.LinearSolverParameter('method', 
                                 tip=parameter.emptyTipString)],
    tip="linear numerical method to solve system of linear equations associated to finite element mesh",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/linear_driver.xml')
    )


##
## NewtonDriver is a Newton-Raphson iterator.
## It is meant to provide a general framework for
## the solution of properties with field-dependent
## problems.
##
##
class NewtonDriver(Driver):
    def __init__(self, method, newton_tolerance, newton_max_iterations):
        self.method = method
        self.mesh = None ## mesh is a who object
        self.core = None
        self.newton_tolerance = newton_tolerance
        self.newton_max_iterations = newton_max_iterations
        self.iterationMgr = NewtonIterationManager(self.newton_max_iterations,
                                                self.newton_tolerance)
        self.status = None ## state of the linear solver at each step

    def iterate(self, verbosity = 1):
        ## Internal components are silent. Only the Newton Driver
        ## reports to the user
        linear_verbosity = 0

        self.iterationMgr.start()
        while not self.iterationMgr.status():
            self.precompute(linear_verbosity)

            ## Check residual here.  It may not be necessary to
            ## continue.  This must be done *after* calling
            ## precompute(), because precompute() recomputes the
            ## stiffness matrix and rhs using the current x.
            self.iterationMgr.set_residual(self.core.residual())
            if self.iterationMgr.status():
                break
            self.apply_solver(linear_verbosity)
            self.postcompute(linear_verbosity)
            self.subproblemctxt.solutiontimestamp.increment()
            self.iterationMgr.step_completed()
            
        if verbosity:
            nr_residual = self.iterationMgr.get_residual()
            num_steps = self.iterationMgr.get_nsteps()
            if nr_residual < self.newton_tolerance and \
                   self.iterationMgr.status() == "Succeeded":
                reporter.report("Newton method converged! residual=%g nsteps=%d"
                                 % (nr_residual, num_steps))
            else:
                reporter.report("Newton method failed! residual=%g nsteps=%d"
                                % (nr_residual, num_steps))

    def driver_apply(self, stepper, verbosity):
        self.core = NewtonDriverCore(stepper, self.method, self.subproblem)
        self.iterate(verbosity)
        
        

registeredclass.Registration(
    'NewtonDriver',
    Driver,
    NewtonDriver,
    ordering=200,
    params=[
    solver.LinearSolverParameter('method',
                                 tip='The linear solver used at each step of the Newton-Raphson procedure.'),
    parameter.FloatParameter('newton_tolerance', 1e-8,
                             tip='Convergence criterion.'),
    parameter.IntParameter('newton_max_iterations', 10,
                           tip='Maximum number of Newton steps.')
    ],
    tip='Newton-Raphson solver for the solution of non-linear equations.',
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/newton_driver.xml')
    )
